Bug 1151550 - Possibly wrong deps (again)
Summary: Possibly wrong deps (again)
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: imsettings
Version: 21
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Akira TAGOH
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-10-10 16:27 UTC by Ankur Sinha (FranciscoD)
Modified: 2014-11-14 12:07 UTC (History)
9 users (show)

Fixed In Version: imsettings-1.6.7-6.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-11-14 12:07:14 UTC


Attachments (Terms of Use)
debugdata directory (6.93 MB, application/x-gzip)
2014-10-10 16:27 UTC, Ankur Sinha (FranciscoD)
no flags Details

Description Ankur Sinha (FranciscoD) 2014-10-10 16:27:07 UTC
Created attachment 945725 [details]
debugdata directory

Description of problem:
I know dnf has a completely different depsolver, but I still think this is worth reporting. I wanted to install im-chooser today. With yum, I get this:

======================================================================================================================================================================== Package                                        Arch                                Version                                   Repository                           Size
========================================================================================================================================================================Installing:
 im-chooser                                     x86_64                              1.6.4-4.fc21                              fedora                               30 k
Installing for dependencies:
 im-chooser-common                              x86_64                              1.6.4-4.fc21                              fedora                              233 k
 imsettings                                     x86_64                              1.6.7-5.fc21                              fedora                              212 k
 imsettings-libs                                x86_64                              1.6.7-5.fc21                              fedora                              117 k
 imsettings-qt                                  x86_64                              1.6.7-5.fc21                              fedora                              107 k

Transaction Summary
========================================================================================================================================================================Install  1 Package (+4 Dependent packages)

Total download size: 699 k


Which makes sense. 



With DNF, I get this:


Dependencies resolved.
========================================================================================================================================================================
 Package                                              Arch                     Version                                          Repository                         Size
========================================================================================================================================================================
Installing:
 PyPAM                                                x86_64                   0.5.0-21.fc21                                    fedora                             30 k
 cinnamon                                             x86_64                   2.4.0-0.3.git8304e57.fc21                        updates-testing                   2.4 M
 cinnamon-control-center                              x86_64                   2.4.0-0.1.git9677670.fc21                        updates-testing                   1.9 M
 cinnamon-control-center-filesystem                   x86_64                   2.4.0-0.1.git9677670.fc21                        updates-testing                    12 k
 cinnamon-desktop                                     x86_64                   2.4.0-0.1.gitf4ee205.fc21                        updates-testing                   202 k
 cinnamon-menus                                       x86_64                   2.4.0-0.1.gitf22e07d.fc21                        updates-testing                    63 k
 cinnamon-screensaver                                 x86_64                   2.4.0-0.2.git8de7ff0.fc21                        updates-testing                   104 k
 cinnamon-session                                     x86_64                   2.4.0-0.1.git8c1b918.fc21                        updates-testing                   313 k
 cinnamon-settings-daemon                             x86_64                   2.4.0-0.1.gitec2ca3a.fc21                        updates-testing                   1.1 M
 cinnamon-translations                                noarch                   2.2.3-3.fc21                                     fedora                            2.1 M
 cjs                                                  x86_64                   1:2.4.0-0.3.git7a65cc7.fc21                      updates-testing                   237 k
 gnome-icon-theme-legacy                              noarch                   3.12.0-2.fc21                                    fedora                            422 k
 gnome-icon-theme-symbolic                            noarch                   3.12.0-2.fc21                                    fedora                            202 k
 gnome-themes                                         noarch                   2.32.0-12.fc21                                   fedora                            1.3 M
 gstreamer-python                                     x86_64                   0.10.22-7.fc21                                   fedora                            321 k
 gtk-murrine-engine                                   x86_64                   0.98.2-7.fc21                                    fedora                            126 k
 gtk2-engines                                         x86_64                   2.20.2-9.fc21                                    fedora                            313 k
 im-chooser                                           x86_64                   1.6.4-4.fc21                                     fedora                             30 k
 im-chooser-common                                    x86_64                   1.6.4-4.fc21                                     fedora                            233 k
 imlib2                                               x86_64                   1.4.6-2.fc21                                     fedora                            211 k
 imsettings                                           x86_64                   1.6.7-5.fc21                                     fedora                            212 k
 imsettings-cinnamon                                  x86_64                   1.6.7-5.fc21                                     fedora                            107 k
 imsettings-libs                                      x86_64                   1.6.7-5.fc21                                     fedora                            117 k
 metacity                                             x86_64                   3.12.0-2.fc21                                    fedora                            1.1 M
 mintlocale                                           noarch                   1.1.6-0.3.gitfb4118d.fc21                        fedora                            173 k
 muffin                                               x86_64                   2.4.0-0.1.gita9a68ed.fc21                        updates-testing                   1.0 M
 nemo                                                 x86_64                   2.4.0-0.1.git676b171.fc21                        updates-testing                   837 k
 nemo-extensions                                      x86_64                   2.4.0-0.1.git676b171.fc21                        updates-testing                    31 k
 network-manager-applet                               x86_64                   0.9.9.0-15.git20140424.fc21                      updates-testing                   206 k
 opencv-python                                        x86_64                   2.4.9-3.fc21                                     fedora                            389 k
 tint2                                                x86_64                   0.11-12.fc21                                     fedora                            102 k
 tintwizard                                           noarch                   0.3.4-8.fc21                                     fedora                             37 k
 zukitwo-common                                       noarch                   20131210-2.fc21                                  fedora                             19 k
 zukitwo-gtk2-theme                                   noarch                   20131210-2.fc21                                  fedora                             27 k
 zukitwo-gtk3-theme                                   noarch                   20131210-2.fc21                                  fedora                             60 k

Transaction Summary
========================================================================================================================================================================
Install  35 Packages

Total download size: 16 M
Installed size: 61 M
Is this ok [y/N]:


Which really shouldn't be - it isn't logical - I'm not sure how the algorithm works, so this may be "correct", but I'd think it needs to at least be looked at?



Version-Release number of selected component (if applicable):
[asinha@localhost  ~]$ dnf --version
0.6.1
  Installed: dnf-0:0.6.1-99.576.20141009git883a271.fc21.noarch at 2014-10-10 09:02
  Built    :  at 2014-10-09 10:37

  Installed: rpm-0:4.12.0.1-2.fc21.x86_64 at 2014-10-03 10:50
  Built    : Fedora Project at 2014-10-01 07:40
[asinha@localhost  ~]$

and

[asinha@localhost  ~]$ dnf --version
0.6.2
  Installed: dnf-0:0.6.2-1.fc21.noarch at 2014-10-10 16:24
  Built    : Fedora Project at 2014-10-03 12:40

  Installed: rpm-0:4.12.0.1-2.fc21.x86_64 at 2014-10-03 10:50
  Built    : Fedora Project at 2014-10-01 07:40


How reproducible:
Always

Steps to Reproduce:
1. On a workstation install, try to install im-chooser
2. 
3.

Actual results:
Wants to also install cinnamon, while yum doesn't

Expected results:
Not sure - should it try to install cinnamon?

Additional info:
debugdata attached.

Comment 1 Ankur Sinha (FranciscoD) 2014-10-10 16:33:23 UTC
IM chooser tells me it doesn't work on gnome any more, which *could* be why dnf installs cinnamon along with it. I'm not sure how to investigate this :)

Comment 2 Parag Nemade 2014-10-11 09:00:05 UTC
strange that cinnamon is getting pulled. something should be wrong by some package(maybe imsettings) that is pulling cinnamon.

Comment 3 Tim Lauridsen 2014-10-12 06:44:19 UTC
I think it is a good idea add some debug data

http://dnf.baseurl.org/2013/11/25/reporting-depsolving-bugs/

Comment 4 Parag Nemade 2014-10-12 07:06:16 UTC
I think reporter has already attached debug data in original comment :)

I checked that already but not sure where to look more to find this issue.

Comment 5 Tim Lauridsen 2014-10-12 07:11:46 UTC
Sorry, missed that :-)

imsettings require imsettings-desktop-module(x86-64) = 1.6.7-5.fc21

sudo dnf repoquery --whatprovides "imsettings-desktop-module(x86-64)"
imsettings-cinnamon-0:1.6.7-5.fc21.x86_64
imsettings-gsettings-0:1.6.7-5.fc21.x86_64
imsettings-lxde-0:1.6.7-5.fc21.x86_64
imsettings-mate-0:1.6.7-5.fc21.x86_64
imsettings-qt-0:1.6.7-5.fc21.x86_64
imsettings-xfce-0:1.6.7-5.fc21.x86_64

yum selects imsettings-qt, but dnf selects imsettings-cinnemon

not at bug

Comment 6 Ankur Sinha (FranciscoD) 2014-10-12 10:05:29 UTC
(In reply to Tim Lauridsen from comment #5)
> Sorry, missed that :-)
> 
> imsettings require imsettings-desktop-module(x86-64) = 1.6.7-5.fc21
> 
> sudo dnf repoquery --whatprovides "imsettings-desktop-module(x86-64)"
> imsettings-cinnamon-0:1.6.7-5.fc21.x86_64
> imsettings-gsettings-0:1.6.7-5.fc21.x86_64
> imsettings-lxde-0:1.6.7-5.fc21.x86_64
> imsettings-mate-0:1.6.7-5.fc21.x86_64
> imsettings-qt-0:1.6.7-5.fc21.x86_64
> imsettings-xfce-0:1.6.7-5.fc21.x86_64
> 
> yum selects imsettings-qt, but dnf selects imsettings-cinnemon
> 
> not at bug

Hrm, but, is there a logic behind which it should select? Or does it select the first in the list, or randomly? 

Is this a packaging bug - should imsettings-desktop-module be split into a separate sub package that these other im subpackages should require - then only the imsettings-desktop-module will be installed, not complete package sets (I'd expect)?

Thanks for looking into this, Parag and Tim,
Warm regards,
Ankur

Comment 7 Tim Lauridsen 2014-10-13 06:55:02 UTC
I think that dnf takes the first one and yum takes the one with the shortest name

Comment 8 Radek Holy 2014-10-13 07:30:17 UTC
Well, first of all, the process is not documented. That means that even if DNF selects the first one now, there is no guarantee it will take the first one in the future.

Comment 9 Ankur Sinha (FranciscoD) 2014-10-13 07:58:15 UTC
Ah, is it possible to may be devise a heuristic to ascertain which should be picked? Maybe the one that pulls in the smallest dep set?

Comment 10 Honza Silhan 2014-10-13 13:47:02 UTC
Weak dependencies should fix the problem (adding suggest, see bug 1149160). This is packaging issue that relies on yum specific behaviour.

Comment 11 Akira TAGOH 2014-10-15 08:11:32 UTC
I don't know which one is better to  "Suggests". it really depends on your desktop and purpose of the install. imsettings-gsettings should be pulled still when trying on GNOME in order to use non-ibus input methods, -qt on KDE etc.

That said given that comps works fine to get them installed properly on Cinnamon, KDE, LXDE, MATE and XFCE, should we still "Suggests" imsettings-gsettings in the spec?

any comments are welcome.

Comment 12 Honza Silhan 2014-10-16 13:47:56 UTC
Akira, if any of the packages is not superior and doesn't cause problems then the best option would be close it as  NOTABUG.

Comment 13 Akira TAGOH 2014-11-06 09:32:14 UTC
Well, not really. it won't work without a proper sub-package installed for desktops. that's why we have an entry in comps to get them installed except GNOME where isn't needed anymore. in that sense, do "Suggests" imsettings-gsettings may be the way to go as a lot of applications uses GTK+.

Comment 14 Fedora Update System 2014-11-06 10:54:25 UTC
imsettings-1.6.7-6.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/imsettings-1.6.7-6.fc21

Comment 15 Fedora Update System 2014-11-07 05:30:39 UTC
Package imsettings-1.6.7-6.fc21:
* should fix your issue,
* was pushed to the Fedora 21 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing imsettings-1.6.7-6.fc21'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-14420/imsettings-1.6.7-6.fc21
then log in and leave karma (feedback).

Comment 16 Fedora Update System 2014-11-14 12:07:14 UTC
imsettings-1.6.7-6.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.